VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMailSlotClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateFileA Lib "kernel32.dll" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function WriteFile Lib "kernel32.dll" (ByVal hFile As Long, ByRef lpBuffer As Byte, ByVal nNumberOfBytesToWrite As Long, ByRef lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long

Private Const GENERIC_WRITE As Long = &H40000000
Private Const FILE_SHARE_READ As Long = &H1&
Private Const OPEN_EXISTING As Long = 3
Private Const FILE_ATTRIBUTE_NORMAL As Long = &H80&

Private mName As String
Private mServer As String
Private mHandle As Long
Private mValid As Boolean


Public Sub Connect(ByRef Name As String, Optional ByRef Server As String = ".")

mHandle = CreateFileA("\\" & Server & "\mailslot\" & Name, GENERIC_WRITE, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0)

If mHandle <> INVALID_HANDLE_VALUE Then
    mName = Name
    mServer = Server
    mValid = True
Else
    RaiseError Err.LastDllError
End If

End Sub


Public Sub Disconnect()

If CloseHandle(mHandle) Then
    mValid = False
Else
    RaiseError Err.LastDllError
End If

End Sub


Public Property Get Name() As String

Name = mName

End Property


Public Property Get Server() As String

Server = mServer

End Property


Public Sub WriteBytes(ByRef Bytes() As Byte)

Dim LowerBound As Long
Dim UpperBound As Long
Dim Result As Long

LowerBound = LBound(Bytes, 1)
UpperBound = UBound(Bytes, 1)

If WriteFile(mHandle, Bytes(LowerBound), UpperBound - LowerBound + 1, Result, 0) = 0 Then RaiseError Err.LastDllError

End Sub


Public Sub WriteString(ByRef Text As String, Optional ByVal Unicode As Boolean = False)

Dim Buffer() As Byte

If Unicode Then
    Buffer = Text
Else
    Buffer = StrConv(Text, vbFromUnicode)
End If

WriteBytes Buffer

End Sub


Private Sub Class_Terminate()

If mValid Then Disconnect

End Sub
