VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMailSlotServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateMailslotA Lib "kernel32.dll" (ByVal lpName As String, ByVal nMaxMessageSize As Long, ByVal lReadTimeout As Long, ByVal lpSecurityAttributes As Long) As Long
Private Declare Function GetMailslotInfo Lib "kernel32.dll" (ByVal hMailslot As Long, ByRef lpMaxMessageSize As Long, ByRef lpNextSize As Long, ByRef lpMessageCount As Long, ByRef lpReadTimeout As Long) As Long
Private Declare Function SetMailslotInfo Lib "kernel32.dll" (ByVal hMailslot As Long, ByVal lReadTimeout As Long) As Long
Private Declare Function GetFileTime Lib "kernel32.dll" (ByVal hFile As Long, ByRef lpCreationTime As Currency, ByVal lpLastAccessTime As Long, ByVal lpLastWriteTime As Long) As Long
Private Declare Function SetFileTime Lib "kernel32.dll" (ByVal hFile As Long, ByRef lpCreationTime As Currency, ByVal lpLastAccessTime As Long, ByVal lpLastWriteTime As Long) As Long
Private Declare Function ReadFile Lib "kernel32.dll" (ByVal hFile As Long, ByRef lpBuffer As Byte, ByVal nNumberOfBytesToRead As Long, ByRef lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long

Private mName As String
Private mHandle As Long
Private mValid As Boolean

Public Enum MailslotConstants
    MailslotDoNotWait = 0
    MailslotWaitForever = -1
    MailslotNoMessage = -1
End Enum


Public Sub Create(ByRef Name As String, Optional ByVal MaxMessageSize As Long = 0, Optional ByVal ReadTimeOut As Long = MailslotDoNotWait)

mHandle = CreateMailslotA("\\.\mailslot\" & Name, MaxMessageSize, ReadTimeOut, 0)

If mHandle <> INVALID_HANDLE_VALUE Then
    mName = Name
    mValid = True
Else
    RaiseError Err.LastDllError
End If

End Sub


Public Sub Destroy()

If CloseHandle(mHandle) Then
    mValid = False
Else
    RaiseError Err.LastDllError
End If

End Sub


Public Property Get Name() As String

Name = mName

End Property


Public Property Get MaxMessageSize() As Long

If GetMailslotInfo(mHandle, MaxMessageSize, ByVal 0, ByVal 0, ByVal 0) = 0 Then RaiseError Err.LastDllError

End Property


Public Property Get NextMessageSize() As Long

If GetMailslotInfo(mHandle, ByVal 0, NextMessageSize, ByVal 0, ByVal 0) = 0 Then RaiseError Err.LastDllError

End Property


Public Property Get MessageCount()

If GetMailslotInfo(mHandle, ByVal 0, ByVal 0, MessageCount, ByVal 0) = 0 Then RaiseError Err.LastDllError

End Property


Public Property Get ReadTimeOut() As Long

If GetMailslotInfo(mHandle, ByVal 0, ByVal 0, ByVal 0, ReadTimeOut) = 0 Then RaiseError Err.LastDllError

End Property


Public Property Let ReadTimeOut(ByVal NewValue As Long)

If SetMailslotInfo(mHandle, NewValue) = 0 Then RaiseError Err.LastDllError

End Property


Public Property Get CreationTime() As Date

Dim Internal As Currency

If GetFileTime(mHandle, Internal, 0, 0) Then
    CreationTime = CDate(CDbl(Internal / 86400000@) - 109205#)
Else
    RaiseError Err.LastDllError
End If

End Property


Public Property Let CreationTime(ByVal NewValue As Date)

Dim Internal As Currency

Internal = CCur((CDbl(NewValue) + 109205#) * 86400000#)

If SetFileTime(mHandle, Internal, 0, 0) = 0 Then RaiseError Err.LastDllError

End Property


Public Function ReadBytes(Optional ByVal Size As Long = 0) As Byte()

Dim Available As Long
Dim Buffer() As Byte
Dim Result As Long

Available = NextMessageSize

If Available >= 0 Then
    If Size <= 0 Then Size = Available
    ReDim Buffer(0 To Size - 1)
    If ReadFile(mHandle, Buffer(0), Size, Result, 0) Then
        ReadBytes = Buffer
    Else
        RaiseError Err.LastDllError
    End If
End If

End Function


Public Function ReadString(Optional ByVal Length As Long = 0, Optional ByVal Unicode As Boolean = False) As String

If Unicode Then
    ReadString = ReadBytes(Length * 2)
Else
    ReadString = StrConv(ReadBytes(Length), vbUnicode)
End If

End Function


Private Sub Class_Terminate()

If mValid Then Destroy

End Sub
